diff --git a/encoder/encoder.c b/encoder/encoder.c
index 169ab72..682340b 100644
--- a/encoder/encoder.c
+++ b/encoder/encoder.c
@@ -849,8 +849,16 @@ int x264_encoder_reconfig( x264_t *h, x264_param_t *param )
         COPY( analyse.b_transform_8x8 );
     if( h->frames.i_max_ref1 > 1 )
         COPY( b_bframe_pyramid );
+
+    COPY( vui );
+    COPY( vui.i_sar_width );
+    COPY( vui.i_sar_height );
 #undef COPY
 
+    // for dynamic aspect ratio change
+    h->sps->vui.i_sar_width = h->param.vui.i_sar_width;
+    h->sps->vui.i_sar_height = h->param.vui.i_sar_height;
+
     mbcmp_init( h );
 
     return x264_validate_parameters( h );
